package calendarapp.plugins;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

public class PluginClassLoader extends ClassLoader {
	private static final String exportedPackage = "calendarapp.plugins.exported";

	@Override
	public Class<?> findClass (String name) {
		byte[] data = loadClassData (name);
		return defineClass(exportedPackage + "." + name, data, 0, data.length);
	}

	private byte[] loadClassData (String name) {
		File f = new File(PluginLoader.pluginPath + name + ".class");
		ByteArrayOutputStream classBuffer = new ByteArrayOutputStream();

		// TODO E4: Use the above File instance together with an input stream to
		// read information from the file. Append each read byte into classBuffer.
		// If correctly implemented, a working class definition will be returned
		// to PluginLoader when it calls this class.
		//
		// TIP: A good method is to use "new FileInputStream(f)".

		return classBuffer.toByteArray();
	}
}
