package edu.chl.hajo.monopoly.core;

import java.util.ArrayList;
import java.util.List;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 This is a test for a single class.
 Board is a bit complex so create test for it

 @author hajo
 */
public class TestBoard {

    // This will later come from file
    public static final String SPACE_NAMES
            = "go,1:1,cc1,1:2,income,train1,2:1,chance1,2:2,2:3,"
            + "jail,3:1,electric,3:2,3:3,train2,4:1,cc2,4:2,4:3,"
            + "parking,5:1,chanc2e,5:2,5:3,train3,6:1,6:2,water,6:3,"
            + "gotojail,7:1,7:2,cc3,7:3,train4,chance3,8:1,luxury,8:2";

    @Test
    public void testBoardCreated() {
        Board b = new Board(getSpaces(SPACE_NAMES));
        assertTrue(b.size() == SPACE_NAMES.split(",").length);
        assertTrue(b.getStart().getName().equals("go"));
    }

    @Test
    public void testGetSpaceRelativeActual() {
        Board b = new Board(getSpaces(SPACE_NAMES));
        Space s = b.getSpace(b.getStart(), 0);
        assertTrue(s.equals(b.getStart()));
        s = b.getSpace(b.getStart(), 10);
        assertTrue(s.getName().equals("jail"));
        s = b.getSpace(b.getStart(), 20);
        assertTrue(s.getName().equals("parking"));
        s = b.getSpace(b.getStart(), 30);
        assertTrue(s.getName().equals("gotojail"));
        s = b.getSpace(b.getStart(), 40);
        assertTrue(s.equals(b.getStart()));
        s = b.getSpace(b.getStart(), 41);
        assertTrue(s.getName().equals("1:1"));
    }

    @Test
    public void testGetGoPassed() {
        Board b = new Board(getSpaces(SPACE_NAMES));
        assertFalse(b.passedGo(b.getStart(), b.getSpace(1)));
        assertFalse(b.passedGo(b.getSpace(20), b.getSpace(25)));
        assertTrue(b.passedGo(b.getSpace(39), b.getStart()));
        assertTrue(b.passedGo(b.getSpace(35), b.getSpace(15)));

    }

    // ------  Helpers -------------------
    public static List<Space> getSpaces(String names) {
        List<Space> sps = new ArrayList<>();
        for (String name : names.split(",")) {
            sps.add(new Space(name));
        }
        return sps;
    }
}
